#include <stdio.h>      /* fprintf */
#include <stdlib.h>     /* atoi */
#include <stddef.h>     /* ptrdiff_t */
#include <string.h>

#include <pfft.h>
#include <ipfft.h>

static int count_given_args(
    int argc, char **argv, int iter);
static int enough_arguments_given(
    int argc, char **argv, int iter, int neededArgs);
static int strings_match(
    char *str1, char *str2);



void PX(get_arg_INT)(
    int argc, char **argv, char *name, int neededArgs, ptrdiff_t *parameter
    )
{
  for(int iter=0; iter<argc; iter++){
    if ( strings_match( argv[iter], name ) ){
      if ( !enough_arguments_given(argc, argv, iter, neededArgs) )
        fprintf(stderr, "!!! Warning: Not enough command line arguments for %s !!!\n", name);
      else
        for(int t=0; t<neededArgs; t++)
          parameter[t] = atoi(argv[++iter]);
    }
  }
}

void PX(get_arg_int)(
    int argc, char **argv, char *name, int neededArgs, int* parameter
    )
{
  for(int iter=0; iter<argc; iter++){
    if ( strings_match( argv[iter], name ) ){
      if ( !enough_arguments_given(argc, argv, iter, neededArgs) )
        fprintf(stderr, "!!! Warning: Not enough command line arguments for %s !!!\n", name);
      else
        for(int t=0; t<neededArgs; t++)
          parameter[t] = atoi(argv[++iter]);
    }
  }
}

static int count_given_args(
    int argc, char **argv, int iter
    )
{
  int givenArgs;
  for(givenArgs=0; (iter+givenArgs+1) < argc; givenArgs++)
    if (argv[iter+givenArgs+1][0] == '-')
      break;

  return givenArgs;
}

static int enough_arguments_given(
    int argc, char **argv, int iter, int neededArgs
    )
{
  int givenArgs;
  givenArgs = count_given_args(argc, argv, iter);
  return givenArgs >= neededArgs;
}

static int strings_match(
    char *str1, char *str2
    )
{
  return !strcmp(str1, str2);
}


